/*
 * Cata_Joc.c
 *
 * Created: 5/24/2013 1:25:43 AM
 *  Author: cata
 */ 


#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>


#define COLUMNS		    PORTA
#define LINES_RED	    PORTC

#define RESET_DDRA      0xFF 
#define CLEAR_COL       0x00 
#define RESET_DDRC      0xFF 
#define CLEAR_RED       0xFF 

//nuamrul maxim de linii/coloane => dimensiunea matricii de leduri
#define ROW 8
#define COL 8

#define LEFT 0
#define RIGHT 1

//directiile sunt definite astfel pentru a putea fi intelese
#define N 0
#define NE 1
#define E 2
#define SEE 3
#define S 4
#define SW 5
#define W 6
#define NW 7 

int map[ROW][COL];
//pozitia curenta a mingii ball_pos[0] = ROW & ball_pos[1] = COL 
int ball_pos[2];
//variabile cu care ne vom da seama daca se poate misca bara
int left_margin, right_margin;
//
int current_dir;
//numar de leduri inca aprinse(brick)
int counter;			






//functie de resteare/initializare a plansii de joc
void init_map() 
{
	int aux, i, j;
	//primele doua linii au becul aprins iar celalte nu
	for(i = 0; i <= ROW; i++)
	{
		for(j = 0; j < COL; j++)
		{
			if(i == 0 || i == 1)
				aux = 1;
			else 
				aux = 0;
			map[i][j] = aux;
		}
	}
	
	map[7][2] = map [7][3] = map[7][4] = map[6][3] = 1;
	
	left_margin = 2; right_margin = 4;
	
	ball_pos[0] = 6; ball_pos[1] = 3;

	current_dir = NE; counter = 16;
}



int test_ball(int i, int j)
{
	if(i < 0 || i > 7 || j < 0 || j > 7)
		return 1;
	if(map[i][j] == 1)
		return 1;
	return 0;
}

void move_ball()
{
	switch(current_dir)
	{
	
	case N:
		if(test_ball(ball_pos[0] - 1, ball_pos[1]))
		{
			if(ball_pos[0] == 0)
			{
				current_dir = S;
				move_ball();
			}

			if(map[ball_pos[0] + 1][ball_pos[1] ] == 1)
			{
				counter--;
				map[ball_pos[0] + 1][ball_pos[1] ] = 0;
				current_dir = S;
				move_ball();
			}

		}
		else
		{
			map[ball_pos[0] ][ball_pos[1] ] = 0;
			ball_pos[0] -= 1;
			map[ball_pos[0] ][ball_pos[1] ] = 1;
		}
		break;
	
	case NE:
		if(test_ball(ball_pos[0] - 1, ball_pos[1] + 1))
		{
			if(ball_pos[0] == 0)
			{
				current_dir = SEE;
				move_ball();
			}

			if(ball_pos[1] == 7)
			{
				current_dir = NW;
				move_ball();
			}

			if(map[ball_pos[0] - 1][ball_pos[1] + 1] == 1)
			{
				counter--;
				map[ball_pos[0] - 1][ball_pos[1] + 1] = 0;
				current_dir = SEE;
				move_ball();
			}
		}
		else
		{
			map[ball_pos[0] ][ball_pos[1] ] = 0;
			ball_pos[0] -= 1; 
			ball_pos[1] += 1;
			map[ball_pos[0] ][ball_pos[1] ] = 1;
		}
		break;
	
	case E:
		if(test_ball(ball_pos[0], ball_pos[1] + 1))
		{
			if(ball_pos[1] == 7);
			{
				current_dir = W;
				move_ball();
			}
		}
		else
		{
			map[ball_pos[0] ][ball_pos[1] ] = 0;
			ball_pos[1] += 1; 
			map[ball_pos[0] ][ball_pos[1] ] = 1;
		}
		break;
	
	case SEE:
		if(test_ball(ball_pos[0] + 1, ball_pos[1] + 1))
		{
			if(ball_pos[1] == 7)
			{
				current_dir = SW;
				move_ball();
			}



			if(ball_pos[1] == left_margin - 1 && ball_pos[0] == 6)
			{
				current_dir = NW;
				move_ball();
			
			}

			if(ball_pos[1] == left_margin && ball_pos[0] == 6)
			{
				current_dir = NE;
				move_ball();
			}

			if(ball_pos[1] == left_margin + 1 && ball_pos[0] == 6)
			{
				current_dir = NE;
				move_ball();
			
			}

			if(ball_pos[1] == right_margin && ball_pos[0] == 6)
			{
				current_dir = NE;
				move_ball();
			}

			if(map[ball_pos[0] + 1][ball_pos[1] + 1] == 1)
			{
				counter--;
				map[ball_pos[0] + 1][ball_pos[1] + 1] = 0;
				current_dir = NE;
				move_ball();
			}


		}
		else
		{
			if(ball_pos[1] == right_margin && ball_pos[0] == 6)
			{
				current_dir = NE;
				move_ball();
			}
			else
			{
				map[ball_pos[0] ][ball_pos[1] ] = 0;
				ball_pos[0] += 1; 
				ball_pos[1] += 1;
				map[ball_pos[0] ][ball_pos[1] ] = 1;
			}
		}
		break;
	
	case S:
		if(test_ball(ball_pos[0] + 1, ball_pos[1]))
		{
			

			if(ball_pos[1] == left_margin && ball_pos[0] == 6)
			{
				current_dir = NW;
				move_ball();
			}

			if(ball_pos[1] == left_margin + 1 && ball_pos[0] == 6)
			{
				current_dir = N;
				move_ball();
			
			}

			if(ball_pos[1] == left_margin + 2 && ball_pos[0] == 6)
			{
				current_dir = NE;
				move_ball();
			}

			if(map[ball_pos[0] + 1][ball_pos[1] ] == 1)
			{
				counter--;
				map[ball_pos[0] + 1][ball_pos[1] ] = 0;
				current_dir = N;
				move_ball();
			}
		}
		else
		{
			map[ball_pos[0] ][ball_pos[1] ] = 0;
			ball_pos[0] += 1;
			map[ball_pos[0] ][ball_pos[1] ] = 1;
		}
		break;
	
	case SW:
		if(test_ball(ball_pos[0] + 1, ball_pos[1] - 1))
		{
			if(ball_pos[1] == 0)
			{
				current_dir = SEE;
				move_ball();
			}

			if(ball_pos[1] == right_margin + 1 && ball_pos[0] == 6)
			{
				current_dir = NE;
				move_ball();
			
			}

			if((ball_pos[1] == right_margin || ball_pos[1] == right_margin - 1
			   || ball_pos[1] == right_margin - 2) && ball_pos[0] == 6)
			{
				current_dir = NW;
				move_ball();
			}

			if(map[ball_pos[0] + 1][ball_pos[1] - 1] == 1)
			{
				counter--;
				map[ball_pos[0] + 1][ball_pos[1] - 1] = 0;
				current_dir = NW;
				move_ball();
			}

		}
		else
		{
			if(ball_pos[1] == left_margin && ball_pos[0] == 6)
			{
				current_dir = NW;
				move_ball();
			}
			else
			{
				map[ball_pos[0] ][ball_pos[1] ] = 0;
				ball_pos[0] += 1; 
				ball_pos[1] -= 1;
				map[ball_pos[0] ][ball_pos[1] ] = 1;
			}
		}
		break;
	
	case W:
		if(test_ball(ball_pos[0], ball_pos[1] - 1))
		{
			if(ball_pos[1] == 0);
			{
				current_dir = E;
				move_ball();
			}
		}
		else
		{
			map[ball_pos[0] ][ball_pos[1] ] = 0;
			ball_pos[1] -= 1; 
			map[ball_pos[0] ][ball_pos[1] ] = 1;
		}
		break;
	
	case NW:
		if(test_ball(ball_pos[0] - 1, ball_pos[1] - 1))
		{
			if(ball_pos[0] == 0)
			{
				current_dir = SW;
				move_ball();
			}

			if(ball_pos[1] == 0)
			{
				current_dir = NE;
				move_ball();
			}

			if(map[ball_pos[0] - 1][ball_pos[1] - 1] == 1)
			{
				counter--;
				map[ball_pos[0] - 1][ball_pos[1] - 1] = 0;
				current_dir = SW;
				move_ball();
			}
		}
		else
		{
			map[ball_pos[0] ][ball_pos[1] ] = 0;
			ball_pos[0] -= 1; 
			ball_pos[1] -= 1;
			map[ball_pos[0] ][ball_pos[1] ] = 1;
		}
		break;
	
	default:
		break;
	}
}

void move(int direction)
{
	//left
	if(direction == LEFT)
	{
		if(left_margin != 0)
		{
			map[7][left_margin - 1] = 1; 
			map[7][right_margin] = 0; 

			left_margin--;
			right_margin--;
		}
	}

	//right
	else
	{
		if(right_margin != 7)
		{
			map[7][left_margin] = 0; 
			map[7][right_margin + 1] = 1; 

			left_margin++;
			right_margin++;
		}
	}
}

void enableColumn(int column)
{
	if (column == 0)
        COLUMNS |= 1<<PA0;
    else if (column == 1)
        COLUMNS |= 1<<PA1;
    else if (column == 2)
        COLUMNS |= 1<<PA2;
    else if (column == 3)
        COLUMNS |= 1<<PA3;
    else if (column == 4)
        COLUMNS |= 1<<PA6;
    else if (column == 5)
        COLUMNS |= 1<<PA5;
    else if (column == 6)
        COLUMNS |= 1<<PA4;
    else if (column == 7)
    	COLUMNS |= 1<<PA7;
}

void enableLineRed(int line)
{
	if (line == 0)
        LINES_RED &= ~(1<<PC7);
    else if (line == 1)
        LINES_RED &= ~(1<<PC6);
    else if (line == 2)
        LINES_RED &= ~(1<<PC5);
    else if (line == 3)
        LINES_RED &= ~(1<<PC4);
    else if (line == 4)
        LINES_RED &= ~(1<<PC3);
    else if (line == 5)
        LINES_RED &= ~(1<<PC2);
    else if (line == 6)
        LINES_RED &= ~(1<<PC1);
    else if (line == 7)
        LINES_RED &= ~(1<<PC0);

}

void lightRed(int i, int j)
{
	enableColumn(j);
	enableLineRed(i);
}

void lightOff()
{
	COLUMNS = CLEAR_COL;
	LINES_RED = CLEAR_RED;
}

void print_matrix()
{
	int i, j;
	for(i = 0; i < 8; i++){
		for(j = 0; j < 8; j++)
		{
			if(map[i][j] == 1)
			{
				lightRed(i, j);
			}
			
		}
		_delay_ms(1);
		lightOff();
	}
}

int main (void) {
	int i;
	
	// Setam PORTA pentru 1 buton si 7 coloane
	DDRA = RESET_DDRA;
	PORTA = CLEAR_COL;

	// Setam PORTC pentru 5 linii RED si 3 butoane
	DDRC = RESET_DDRC;
	PORTC = CLEAR_RED;
	
	PORTD = 0;
	PORTD |= (1 << PD0) | (1 << PD1);
	
	init_map();
	
	while(1) {
	
		if (!(PIND & (1 << PD0))) {
			while (!(PIND & (1 << PD0))) {
				print_matrix();
			}
			move(LEFT);	
		
		} else  if (!(PIND & (1 << PD1))) {
			
			while (!(PIND & (1 << PD1))) {
				print_matrix();
			}
			
			move(RIGHT);
		}
		
		for (i = 0; i < 100; i++) { 
			print_matrix();
		}
	
		move_ball();
	}	
		
	return 0;
}